<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:lav="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                exclude-result-prefixes="xalan lav">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>
    <xsl:strip-space elements="lav:*"/>
    <xsl:variable name="XSL">http://www.w3.org/1999/XSL/Transform</xsl:variable>

    <xsl:template match="/lav:config">
        <xsl:element name="stylesheet" namespace="{$XSL}">
            <xsl:attribute name="version">1.0</xsl:attribute>

            <xsl:for-each select="lav:view-template[not(@stylesheet=preceding-sibling::lav:view-template/@stylesheet)]">
                <xsl:element name="include" namespace="{$XSL}">
                    <xsl:attribute name="href">
                        <xsl:value-of select="@stylesheet"/>
                    </xsl:attribute>
                </xsl:element>
            </xsl:for-each>

            <xsl:element name="output" namespace="{$XSL}">
                <xsl:attribute name="method">xml</xsl:attribute>
            </xsl:element>

            <xsl:element name="template" namespace="{$XSL}">
                <xsl:attribute name="match">*</xsl:attribute>
                <xsl:element name="copy" namespace="{$XSL}">
                    <xsl:element name="copy-of" namespace="{$XSL}">
                        <xsl:attribute name="select">@*</xsl:attribute>
                    </xsl:element>
                    <xsl:element name="apply-templates" namespace="{$XSL}"/>
                </xsl:element>
            </xsl:element>
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>