function toDOT() {
    var dot = 'digraph G {';
    var graphml = document.getElementById('graphml').firstElementChild;

    var key = graphml.getElementsByTagName("g:key");
    for (var k=0; k<key.length; k++) {
        var type = key[k].getAttribute('for');
        var name = key[k].getAttribute('id');
        var value = key[k].getElementsByTagName('g:default')[0].textContent;
        dot += type+'['+name+'='+value+']; ';
    }

    var graph = graphml.getElementsByTagName("g:graph");
    for (var g=0; g<graph.length; g++) {
        var node = graph[g].getElementsByTagName('g:node');
        for (var n=0; n<node.length; n++) {
            var id = node[n].getAttribute('id');
            dot += '"'+id+'" ['+data(node[n])+'];';
        }
        var edge = graph[g].getElementsByTagName('g:edge');
        for (var e=0; e<edge.length; e++) {
            var source = edge[e].getAttribute('source');
            var target = edge[e].getAttribute('target');
            dot += '"'+source+'"->"'+target+'" ['+data(edge[e])+'];';
        }
    }

    dot += '}';
    return dot;
}
function data(element) {
    var dot = "";
    var data = element.getElementsByTagName('g:data');
    for (var d=0; d<data.length; d++) {
        dot += data[d].getAttribute('key')+'="'+data[d].textContent+'";';
    }
    return dot;
}
function toSVG() {
    dot = toDOT();
    try {return Viz(dot, "svg", "dot");}
    catch(e) {return printStackTrace(e.toString() + dot);}
}
function printStackTrace(s) {
    return "<pre>" + s.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;") + "</pre>"
}
dom = new DOMParser().parseFromString(toSVG(), "text/xml");
document.getElementById('Graph').innerHTML = new XMLSerializer().serializeToString(dom.documentElement);
