<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:cfg="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                exclude-result-prefixes="cfg">
    <xsl:output method="xml" omit-xml-declaration="yes"/>
    <xsl:variable name="VERSION">5</xsl:variable>

    <xsl:template match="cfg:processor/@type[.='AppendXmlProcessor']">
        <xsl:attribute name="type">InsertXmlProcessor</xsl:attribute>
    </xsl:template>

    <xsl:template match="cfg:processor">
        <xsl:copy>
            <!-- attributes -->
            <xsl:apply-templates select="@*"/>
            <xsl:for-each select="cfg:parameter[@name='nodes']">
                <xsl:attribute name="match"><xsl:value-of select="text()"/></xsl:attribute>
                <xsl:if test="@eval">
                    <xsl:attribute name="generate-match"><xsl:value-of select="@eval"/></xsl:attribute>
                </xsl:if>
            </xsl:for-each>

            <!-- elements -->
            <xsl:for-each select="cfg:parameter[@name='namespaces']/cfg:entry[not(@eval)]">
                <namespace prefix="{@key}" uri="{text()}"/>
            </xsl:for-each>
            <xsl:for-each select="cfg:parameter[@name='variables']/cfg:entry">
                <variable name="{@key}"><xsl:copy-of select="@eval | text()"/></variable>
            </xsl:for-each>
            <xsl:for-each select="cfg:parameter[@name='xml_variables']/cfg:entry">
                <variable name="{@key}" xml="true"><xsl:copy-of select="@eval | text()"/></variable>
            </xsl:for-each>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="cfg:processor/cfg:parameter[@name='nodes' or @name='namespaces' or @name='variables' or @name='xml_variables']"/>

    <!-- common -->
    <xsl:template match="/cfg:config/@version">
        <xsl:attribute name="version">
            <xsl:value-of select="$VERSION"/>
        </xsl:attribute>
    </xsl:template>
    <xsl:template match="@* | comment()" priority="-1">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="*" priority="-1">
        <xsl:copy><xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>