<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:cfg="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                exclude-result-prefixes="cfg">
    <xsl:output method="xml" omit-xml-declaration="yes"/>
    <xsl:variable name="VERSION">7</xsl:variable>

    <xsl:template match="cfg:processor/cfg:parameter[contains(
        '|node_value|node_values|group_by|select|destination_predicate|if_descendant_predicate|',
        concat('|',@name,'|'))
        or (@name='node_name' and parent::cfg:processor/cfg:parameter[@name='node_name_as_xpath']/text()='true')
        ]">
        <xsl:choose>
            <xsl:when test="@eval">
                <xsl:message terminate="yes">
                    You must manually fix this XPath expression and then move it to text node:
                    <xsl:value-of select="@eval"/>
                </xsl:message>
            </xsl:when>
            <xsl:otherwise>
                <xsl:copy><xsl:copy-of select="@*"/>
                    <xsl:attribute name="eval">
                        <xsl:value-of select="normalize-space(text())"/>
                    </xsl:attribute>
                </xsl:copy>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="cfg:processor/cfg:parameter[@name='node_name_as_xpath']"/>

    <xsl:template match="cfg:*[cfg:node/@name_as_xpath='true']">
        <processor match="{@nodes | @context}">
            <xsl:attribute name="type">
                <xsl:choose>
                    <xsl:when test="self::cfg:insert">InsertProcessor</xsl:when>
                    <xsl:when test="self::cfg:replace">ReplaceProcessor</xsl:when>
                </xsl:choose>
            </xsl:attribute>
            <xsl:for-each select="cfg:node/@prefix">
                <parameter name="node_prefix"><xsl:value-of select="@prefix"/></parameter>
            </xsl:for-each>
            <xsl:for-each select="cfg:node/@name">
                <parameter name="node_name" eval="{.}"/>
            </xsl:for-each>
            <xsl:for-each select="cfg:node/@value">
                <parameter name="node_value" eval="{.}"/>
            </xsl:for-each>
        </processor>
    </xsl:template>

    <!-- common -->
    <xsl:template match="/cfg:config/@version">
        <xsl:attribute name="version">
            <xsl:value-of select="$VERSION"/>
        </xsl:attribute>
    </xsl:template>
    <xsl:template match="@* | comment()" priority="-1">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="*" priority="-1">
        <xsl:copy><xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>