<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:cfg="http://software.in2p3.fr/lavoisier/config.xsd">
    <xsl:output method="xml"/>

<xsl:template match="/cfg:config"><entries xmlns="http://software.in2p3.fr/lavoisier/entries.xsd"><entry>digraph G {
    graph [rankdir = "LR"];
    node [shape = "record"];
    edge [];
    <xsl:apply-templates select="cfg:view[cfg:cache]"/>
    <xsl:for-each select="cfg:view/cfg:cache/cfg:trigger[contains(@type,'DependencyRefreshed')]/cfg:parameter[@name='views']/cfg:entry">
        <xsl:text/>"<xsl:value-of select="text()"/>" -> "<xsl:value-of select="ancestor::cfg:view/@name"/>";
    </xsl:for-each>
}</entry></entries>
</xsl:template>

    <xsl:template match="cfg:view[cfg:cache]">
        "<xsl:value-of select="@name"/>" [
            label = "<xsl:value-of select="@name"/> | &lt;triggers&gt; <xsl:apply-templates select="cfg:cache/cfg:trigger"/>"
        ];
    </xsl:template>

    <xsl:template match="cfg:trigger">
        <xsl:variable name="class_name">
            <xsl:call-template name="CLASS_NAME">
                <xsl:with-param name="string" select="@type"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:value-of select="substring-before($class_name, 'Trigger')"/>
        <xsl:text>\n</xsl:text>
    </xsl:template>

    <xsl:template name="CLASS_NAME">
        <xsl:param name="string"/>
        <xsl:choose>
            <xsl:when test="contains($string, '.')">
                <xsl:call-template name="CLASS_NAME">
                    <xsl:with-param name="string" select="substring-after($string, '.')"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$string"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>